/* Allgemeine Funktionen fr alle Zwecke ... */


/* Setzen der Klassen von ...on auf ...off und umgekehrt */
/* Der Klassenname selbst muss nicht bekanntsein. Das    */
/* Objekt wird ber die ID identifiziert.                */
/* Per Vorbelegung sollte die "off"-Klasse angegeben     */
/* werden.                                               */

function setClassOn(idname)
{
   akt_class = document.getElementById(idname).className;

   /* Aus off wird on */
   document.getElementById(idname).className = swap_suffix(akt_class,"off","on");
}

function setClassOff(idname)
{
   akt_class = document.getElementById(idname).className;

   /* Aus on wird off */
   document.getElementById(idname).className = swap_suffix(akt_class,"on","off");
}

/* String-Funktion zum Vertauschen von Text-Endungen            */
/* Beispiel: swap_suffix("hallo du","du","otto") = "hallo otto" */
function swap_suffix(text,old_suffix,new_suffix)
{
   osl = old_suffix.length;
   if (text.substr(text.length - osl, osl) == old_suffix)
   {
      text = text.substr(0,text.length - osl) + new_suffix;
   }
   return text;
}
