// Statistik verwalten


// Codierung der Statistik-Daten
// Es werden bis zu 4 Antworten in ein Zeichen codiert

var stat_encode = new Array();

stat_encode["...."] = "";
stat_encode["0..."] = "0";
stat_encode["1..."] = "1";
stat_encode["00.."] = "2";
stat_encode["01.."] = "3";
stat_encode["10.."] = "4";
stat_encode["11.."] = "5";
stat_encode["000."] = "6";
stat_encode["001."] = "7";
stat_encode["010."] = "8";
stat_encode["011."] = "9";
stat_encode["100."] = "A";
stat_encode["101."] = "B";
stat_encode["110."] = "C";
stat_encode["111."] = "D";
stat_encode["0000"] = "E";
stat_encode["0001"] = "F";
stat_encode["0010"] = "G";
stat_encode["0011"] = "H";
stat_encode["0100"] = "I";
stat_encode["0101"] = "J";
stat_encode["0110"] = "K";
stat_encode["0111"] = "L";
stat_encode["1000"] = "M";
stat_encode["1001"] = "N";
stat_encode["1010"] = "O";
stat_encode["1011"] = "P";
stat_encode["1100"] = "Q";
stat_encode["1101"] = "R";
stat_encode["1110"] = "S";
stat_encode["1111"] = "T";

// Zum Decodieren Assoziatives Array in umgekehrter Richtung aufbauen
stat_decode = new Array();

for (data in stat_encode)
{
   code = stat_encode[data];

   // Date wird um die "." bereinigt
   if (data.indexOf(".") > 0)
   {
      data = data.substr(0,data.indexOf("."));
   }
   
   stat_decode[code] = data;
}


function frage_daten_encode(frage_daten)
{
frage_daten_in = frage_daten;

   var result = "";
   var akt    = "";
   while (frage_daten.length > 0)
   {
      // ggf. auf volle 4 auffllen
      if (frage_daten.length < 4) 
      {
         frage_daten = frage_daten + "....";
         frage_daten = frage_daten.substr(0,4);
      }
      
      // die ersten 4 Zeichen verarbeiten
      akt = frage_daten.substr(0,4);
      if (frage_daten.length > 4)
      {
        frage_daten = frage_daten.substr(4,frage_daten.length - 4); // ab Pos 5
      } else {
        frage_daten = ""; 
      }
 
      // Jetzt kann codiert werden...
      result += stat_encode[akt];
   }
   
   return result;
}

function frage_daten_decode(codestring)
{
   var result = "";
   for (var i = 0; i < codestring.length; i++)
   {
      code = codestring.charAt(i);
      result += stat_decode[code];
   }
// if (codestring.length > 0) alert("code >>"+code+"<< => >>"+result+"<<");
   return result;
}   

function statistik_update(frage_nr, gewusst_jn)
{
	frage_daten[frage_nr] = frage_daten[frage_nr] + gewusst_jn;
}

function statistik_anzeigen()
{

	var statwin = window.open("","StatWindow",
					  "scrollbars=yes,resizable=yes,toolbar=no,location=no,width=700,height=500");
	var i;
	var ueb,frage,ix; // Uebungsnummern durchgehen...
	var anz_r, anz_f; // richtige/falsche Antworten je Frage

	statwin.document.writeln('<HTML><HEAD><link rel="stylesheet" href="style/trainer.css">');
	statwin.document.writeln('<SCRIPT SRC="shared/show_fa.js" LANGUAGE="javascript" TYPE="text/javascript">');
	statwin.document.writeln('</'+'S'+'CRIPT>');// Ende-Tag verstecken
	statwin.document.writeln('<TITLE>' + TRAINER_NAME + ' - Statistik</TITLE>');
	statwin.document.writeln('<SCRIPT SRC="shared/button_close.js" LANGUAGE="javascript" TYPE="text/javascript">');
	statwin.document.writeln('</'+'S'+'CRIPT>');// Ende-Tag verstecken
	statwin.document.writeln('</HEAD><BODY class="stat">');
	statwin.document.writeln('<H1 class="stat">' + TRAINER_NAME + ' - Statistik</H1>');

	anz_ges = 0;
	for (ueb=1; ueb <= UEB_NR_VON.length-1 ; ueb++)
	{
		// Fr welche Kapitel/Unterkapitel die Angaben erfolgen ist
		// im Array ueb-show-stat abgelegt:
		if (UEB_SHOW_STAT[ueb] == 1)
		{

			 statwin.document.writeln('<H2 class="stat"> ' + UEB_NAME[ueb] + '</H2>');

			 statwin.document.writeln('<TABLE class="stat">');

			 var anz = 0;
			 for (frage=UEB_NR_VON[ueb]; frage <= UEB_NR_BIS[ueb]; frage++)
			 {
				 if (frage_daten[frage].length > 1)
				 {
					 statwin.document.write('<TR>');
					 anz++;
					 anz_ges++;
					 anz_r = 0;
					 anz_f = 0;
					 znr   = frage + '_';
					 // Bei Werten ber 1000 wird die Linke stelle abgeschnitten...
					 if (frage >= 1000) 
					 {
						znr   = znr.substr(1, znr.length - 2);
						znr   = znr * 1;// Make numeric
					 } else {
						znr   = frage;
					 }
					 statwin.document.write('<TD><A class="stat" onClick="show_fa('+ueb+','+frage+');return false;">')
					 statwin.document.write('<IMG SRC="shared/info.gif"></TD></A>');
					 statwin.document.write('<TD align="right">' + znr + '</TD>');
					 statwin.document.write('<TD>');
					 for (ant_nr=1; ant_nr <= frage_daten[frage].length - 1; ant_nr++)
					 {
						  if (frage_daten[frage].substr(ant_nr,1) == 1)
						  {
							  statwin.document.write('<IMG SRC="shared/dot_green.gif">');
							  anz_r++;
						  } else {
							  statwin.document.write('<IMG SRC="shared/dot_red.gif">');
							  anz_f++;
						  }
					 }
					 statwin.document.write('</TD>');
					 statwin.document.write("<TD> " + anz_r + " von " + (anz_r + anz_f) + " Fragen richtig.</TD>");
					statwin.document.writeln('</TR>');
				 }
			 } // for frage
	       if (anz > 0)
	  	    {
			    statwin.document.writeln("<BR>");
		    } else {
			    statwin.document.writeln("Sie haben noch keine Frage zu dieser Lektion bearbeitet.<BR>");
		    }
		} // if ueb_show_stat...
		statwin.document.writeln('</TABLE>');
	} // for ueb

	statwin.document.writeln('<P><CENTER>' +
	  '<A href="javascript:close();" ' + 
	  ' onMouseOver="toggle_close(button,2);"' +
	  ' onMouseOut="toggle_close(button,1);">' +
	  '<IMG border=0 name="button" SRC="shared/b_close_low.gif"></A></CENTER>');
	statwin.document.writeln("</BODY></HTML>");
	statwin.document.close();
	statwin.focus();
}
   
   function statistik_loeschen()
   {
      if (confirm(TRAINER_NAME_LANG + "\nWollen Sie die Statistikdaten lschen?"))
      {
         for (var i=frage_daten_von; i<=frage_daten_bis; i++)
         {
            frage_daten[i] = ":";
         }
         alert(TRAINER_NAME_LANG + "\nStatistikdaten wurden gelscht.");
      }
   }

   function statistik_speichern()
   {
      var Verfallszeit = 1000*60*60*24*365;
      
      cookie_string = cookiestring_aus_fragedaten();

      // alert("Cookie wird gesetzt: "+ cookie_string);

      CookieSetzen(TRAINER_COOKIE, cookie_string, Verfallszeit);
      
      alert(TRAINER_NAME_LANG + "\nStatistikdaten wurden gespeichert!");
   }

   function cookiestring_aus_fragedaten()
   {
      // Erzeugt Cookie-String aus Fragedaten 

      // Array komprimieren, da auch Cookies ihre Grenzen haben:
      var cookie_daten = new Array();
      
      // Ggf. mehrmals neu erzeugen, wenn der Speicherbedarf nicht reichen sollte!
      var size_ok = 0;
      cookie_size = 4080; // Speicherplatz im Cookie (16 Bytes f. Namen)

      cut  = 1; // Anzahl nicht gespeicherter Daten je Frage (sofern vorhanden)
      
      while (size_ok == 0)
      {
         cookie_daten = new Array();
         cookie_daten_ix = 1;
         size = 0; // Bentigen Platzbedarf ermitteln 
       
         for (var ueb=1; ueb <= UEB_NR_VON.length - 1; ueb++)
         {
            for (var i=UEB_NR_VON[ueb]; i <= UEB_NR_BIS[ueb]; i++)
            {
               frage_daten_akt = frage_daten[i];
               // Erstes Zeichen ":" nicht bernehmen. Darberhinaus die ersten
               // CUT Zeichen nicht bernehmen.
               if (frage_daten_akt.length >= cut)
               {
                  laenge = frage_daten_akt.length - cut;
                  frage_daten_akt = frage_daten_akt.substr(cut, laenge);
               } else {
                  frage_daten_akt = "";
               }
            
               data = frage_daten_encode(frage_daten_akt);
               cookie_daten[cookie_daten_ix++] = data;
            }
         }
         
         // Platz prfen
         cookie_daten[0]     = cookie_daten_ix;
         cookie_daten_string = cookie_daten.join(",");
         size  = cookie_daten_string.length;
//alert("size:" + size + ", cookie-size: " + cookie_size);
         if (size > cookie_size)
         {
            cut++;
         } else {
            size_ok = 1;
         }
      }
      
      if (cut > 1) 
      {
         cut--;
         alert("Nicht alle Daten konnten im Cookie gespeichert werden,\n" +
               "da dieser eine begrenzte Gre hat.\n"+
               "Die erste(n) " + cut + " Datenstze zu jeder Frage wurden nicht\n" +
               "mehr mitgespeichert.");
      }
      
      
      // Fertig
      return cookie_daten_string;
   }
   
   function fragedaten_aus_cookiestring(cookie_string)
   {
      // Anhand des gelesenen Cookie-String werden wieder 
      // Fragedaten erzeugt:
  
      var cookie_daten = new Array();
      cookie_daten = cookie_string.split(",");

      // Daten den einzelnen Fragenummern wieder zuweisen
      var cookie_daten_ix = 1;
      
      for (var ueb=1; ueb <= UEB_NR_VON.length - 1; ueb++)
      {
         for (var i=UEB_NR_VON[ueb]; i <= UEB_NR_BIS[ueb]; i++)
         {            
            frage_daten[i] = ":" + frage_daten_decode(cookie_daten[cookie_daten_ix++]);
         }
      }
         
      // Wurden genausoviele Elemente gelesen wie gespeichert wurden?
      if (cookie_daten[0] != cookie_daten_ix)
      {
        alert(TRAINER_NAME_LANG + "\nCookie-Daten passen nicht (mehr) zum Trainer!\n\n" + 
          "Wenn die Daten noch richtig angezeigt werden, knnen Sie das Cookie\n"+
          "ber Statistik speichern neu schreiben.\n\n"+
          "Falls die Daten nicht richtig angezeigt werden, sollten Sie das Cookie lschen.");
      }
   }
   
   function statistik_laden(show)
   {
       if (document.cookie) {
       
         Wert = CookieLaden(TRAINER_COOKIE);
       
         if (show) 
         {
            alert(TRAINER_NAME_LANG + "\nStatistikdaten wurden aus Cookie geladen und werden angezeigt ...");
         }
         
         fragedaten_aus_cookiestring(Wert);
         

         if (show) statistik_anzeigen();
         
       } else {
         alert(TRAINER_NAME_LANG + "\n\nEs gibt keinen Cookie mit Statistik-Daten!");
       }
   }
   
   function statistik_laden_bei_start()
   {
       if (document.cookie) 
       {
          // Auf automatisch speichern setzen, da offensichtlich Cookies
          // verwendet werden:
          STATISTIK_AUTOMATISCH_SPEICHERN = 1;
          statistik_laden(0);
       } else {
          STATISTIK_AUTOMATISCH_SPEICHERN = 0;
       }
   }
   
   
   function statistik_cookie_loeschen()
   {
       CookieLoeschen(TRAINER_COOKIE);
       alert("Der Cookie '" + TRAINER_COOKIE + "' wurde in Ihrem Browser gelscht.");
   }
   
// eof   
